#include <windows.h>
#include <math.h>
#include <string.h>

/*
Written by Kenneth E. Moore
June 5, 2000
revised September 15, 2004 to include missing index factor in derivative
*/

int __declspec(dllexport) APIENTRY UserGrinDefinition(double *data);
int __declspec(dllexport) APIENTRY UserParamNames(char *data);

BOOL WINAPI DllMain (HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
	{
   return TRUE;
   }

/* the data is stored as follows:
ndata = the number of elements in the array data
data[0]  = the total number of values in the passed data array
data[1]  = x
data[2]  = y
data[3]  = z
data[4]  = wavelength in µm
data[5]  = millimeters per unit length (1.0 for mm, 25.4 for inches, 10.0 for cm and 1000.0 for meters)
data[6]  = n (to be computed by the dll and returned)
data[7]  = n * dn/dx (to be computed by the dll and returned)
data[8]  = n * dn/dy (to be computed by the dll and returned)
data[9]  = n * dn/dz (to be computed by the dll and returned)
data[10] = parameter 1 from user input
data[11] = parameter 2 from user input
etc... up to data[maxdata] where maxdata = int(data[0])

The DLL must compute data 6 through 9 given the other data,
and return 0 if it works; else return -1
*/

/* this DLL models a GRIN media similar to the GRIN 10 surface type, but no dispersion. */

int __declspec(dllexport) APIENTRY UserGrinDefinition(double *data)
	{
   double y, index;

   y = fabs(data[2]);

   index = data[16];
	index = data[15] + y*index;
	index = data[14] + y*index;
	index = data[13] + y*index;
	index = data[12] + y*index;
	index = data[11] + y*index;
	index = data[10] + y*index;  
	data[6] = index;

   if (index < 1.0)
		{
		return -1;
		}
	
	/* now the derivatives */
   data[7] = 0.0;
   
	data[8] = 6.0 * data[16];
	data[8] = 5.0 * data[15] + y*data[8];
	data[8] = 4.0 * data[14] + y*data[8];
	data[8] = 3.0 * data[13] + y*data[8];
	data[8] = 2.0 * data[12] + y*data[8];
	data[8] =       data[11] + y*data[8];
	if (data[2] < 0.0) data[8] = -data[8];
	data[8] *= index; // this line was missing, fixed 9-15-2004
   
	data[9] = 0.0;
	return 0;
   }


int __declspec(dllexport) APIENTRY UserParamNames(char *data)
	{
	/* this function returns the name of the parameter requested */
	int i;
	i = (int) data[0];
	strcpy(data,"");
	if (i == 1) strcpy(data,"N0");
	if (i == 2) strcpy(data,"N1");
	if (i == 3) strcpy(data,"N2");
	if (i == 4) strcpy(data,"N3");
	if (i == 5) strcpy(data,"N4");
	if (i == 6) strcpy(data,"N5");
	if (i == 7) strcpy(data,"N6");
	return 0;
	}
